%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Initialisierung         
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%  

clear all                                                               % Lsche den workspace
close all                                                               % Schliee alle Fenster
clc                                                                     % Leere das command window
cd('C:\Users\UOHVVCE\Desktop\Auswertung_Verkaufszahlen')                % change directory

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% workspace Laden         
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%  
%load('20181126_norwegen_workspace_rawdata.mat')                         % lade workspace
load('20181215_deutschland_workspace_rawdata.mat') 

rawdata_Deutschland_elektro2030(isnan(rawdata_Deutschland_elektro2030))=0;
rawdata_Deutschland_elektro3040(isnan(rawdata_Deutschland_elektro3040))=0;
rawdata_Deutschland_elektro4065(isnan(rawdata_Deutschland_elektro4065))=0;
rawdata_Deutschland_elektro65end(isnan(rawdata_Deutschland_elektro65end))=0;


verkauf_elektro2030 = sum(rawdata_Deutschland_elektro2030,1);                              % Summiere ber alle Fahrzeuge die Verkufe
verkauf_elektro3040 = sum(rawdata_Deutschland_elektro3040,1);                              % Summiere ber alle Fahrzeuge die Verkufe
verkauf_elektro4065 = sum(rawdata_Deutschland_elektro4065,1);                              % Summiere ber alle Fahrzeuge die Verkufe
verkauf_elektro65end = sum(rawdata_Deutschland_elektro65end,1);    
absatz=[verkauf_elektro2030;verkauf_elektro3040;verkauf_elektro4065;verkauf_elektro65end];

[m,n]=size(absatz);
zeit=[1:n];
preis=[ones(1,n)*25000; ones(1,n)*35000; ones(1,n)*50000; ones(1,n)*80000];
ladepunkte=[[linspace(1,1500,36)] [linspace(1500+900/12,2400,12)] [linspace(2400+400/12,2800,12)] [linspace(2800+2500/12,5300,12)] [linspace(5300+12700/12,18000,12)] [linspace(18000+7000/12,25000,12)] [linspace(25000+10000/12,35000,8)]];%[linspace(25000+1162/12,26162,8)]];
incentive=[[zeros(1,76)] [ones(1,104-76)*4000]];
absatz_opt=reshape(absatz',[1 m*n])';
zeit_opt=reshape(repmat(zeit,1,m),[1 m*n])';
preis_opt=reshape(preis',[1 m*n])';
ladepunkte_opt=reshape(repmat(ladepunkte,1,m),[1 m*n])';
incentive_opt=reshape(repmat(incentive,1,m),[1 m*n])';
incentive_opt(416-104:416)=0;
%reichweite_opt=reshape(repmat(reichweite,1,104),[3120 1]);
%preis_opt=preis_opt-incentive_opt;
test=table(zeit_opt,preis_opt,ladepunkte_opt,absatz_opt);





zeit=[1:104]';
k=length(zeit);
preis=[ones(1,k)*35000; ones(1,k)*40000; ones(1,k)*60000; ones(1,k)*80000];
ladepunkte=[linspace(1,35000,k)]';
preis_opt=reshape(preis',[1 k*4])';
zeit_opt=reshape(repmat(zeit,1,4),[1 k*4])';
ladepunkte_opt=reshape(repmat(ladepunkte,1,4),[1 k*4])';

%incentive_opt=4000*ones(size(zeit_opt));
%reichweite_opt=200*ones(size(zeit_opt));
test2=table(zeit_opt,preis_opt,ladepunkte_opt);
yfit = trainedModel.predictFcn(test2); % SVM Cubic war am besten
ergebnis=reshape(yfit,k,4);
surf(ergebnis);











zeit=[1:200];
preis=[ones(1,200)*20000; ones(1,200)*30000; ones(1,200)*40000; ones(1,200)*50000];
preis_opt=reshape(preis',[1 200*4])';
zeit_opt=reshape(repmat(zeit,1,4),[1 200*4])';

test2=table(zeit_opt,preis_opt);
yfit = trainedModel.predictFcn(test2);
ergebnis=reshape(yfit,200,4);
surf(ergebnis);

